#C Tape Reader demo - Codd's CA

#C In this demo, a stack of coders is repeatedly triggered. The coded
#C sequence is 4666,76,5546,77,7,46. The first four sets are the commands
#C retract-right, extend, extend_right, and sense. These cause the tape
#C head to advance one square and to read the tape cell at that position.
#C An echo signal bounces back: either 6 or 7 depending whether the
#C tape cell was 0 or 1. To keep this demo simple we just delete the echo
#C by colliding a 7 signal with it. The final 46 then caps the end of
#C the read head that was exposed for sensing, and the process can repeat.

#C In Codd's design for a self-replicating machine the echo signal would 
#C instead be passed as output. See echo-discriminator-demo.rle for a demo 
#C that shows how the echo can be used.

#C Within each coder, three gates are required. Two ensure that the 
#C outputs flow in the right direction, the third is to make sure that
#C the first two aren't turned off by later signals.

#U codd.r
#P
 2222222222222222222
21111111111111111 6111111111                    111111111111111111111111
21222222222212222222       1                    1                      1
212        212             1                    1
212        212             1                    1                       1 1 11  111  11  1  1 111 1   11
212        212             1111111111111111111  1
212        212             1   1  1       1     1
212        212             1   1  1       1     1
212        212             1   1111    1  1111  1
212        212             1      1    1111  1  1
212        212             1      1             1
212        212             1      1             1
212        212             1      111111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1  1 1         1     1
212        212             1  111         1     1
212        212             1    111    1  1111  1
212        212             1    1 1    1111  1  1
212        212             1    111111          1
212        212             1       1 1          1
212        212             1       11111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1  1 1         1     1
212        212             1  111         1     1
212        212             1    111    1  1111  1
212        212             1    1 1    1111  1  1
212        212             1    111111          1
212        212             1       1 1          1
212        212             1       11111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1  1 1         1     1
212        212             1  111         1     1
212        212             1    111    1  1111  1
212        212             1    1 1    1111  1  1
212        212             1    111111          1
212        212             1       1 1          1
212        212             1       11111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1   1          1     1
212        212             1   1          1     1
212        212             1   11111   1  1111  1
212        212             1       1   1111  1  1
212        212             1       1            1
212        212             1       1            1
212        212             1       11111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1  1 1         1     1
212        212             1  111         1     1
212        212             1    111    1  1111  1
212        212             1    1 1    1111  1  1
212        212             1    111111          1
212        212             1       1 1          1
212        212             1       11111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1   1 1        1     1
212        212             1   111        1     1
212        212             1     1     1  1111  1
212        212             1     1     1111  1  1
212        212             1     111            1
212        212             1     1 1            1
212        212             1     1111111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1   1 1        1     1
212        212             1   111        1     1
212        212             1     1     1  1111  1
212        212             1     1     1111  1  1
212        212             1     111            1
212        212             1     1 1            1
212        212             1     1111111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1   1  1       1     1
212        212             1   1  1       1     1
212        212             1   1111    1  1111  1
212        212             1      1    1111  1  1
212        212             1      1             1
212        212             1      1             1
212        212             1      111111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1  1 1         1     1
212        212             1  111         1     1
212        212             1    111    1  1111  1
212        212             1    1 1    1111  1  1
212        212             1    111111          1
212        212             1       1 1          1
212        212             1       11111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1   1          1     1
212        212             1   1          1     1
212        212             1   11111   1  1111  1
212        212             1       1   1111  1  1
212        212             1       1            1
212        212             1       1            1
212        212             1       11111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1   1          1     1
212        212             1   1          1     1
212        212             1   11111   1  1111  1
212        212             1       1   1111  1  1
212        212             1       1            1
212        212             1       1            1
212        212             1       11111111111111
212        212             1                    1
212        212             1                    1
212        212             1                    1
212        212             1                    1
212        212             1                    1
212        212             1                    1
212        212             1                    1
212        212             1                    1
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1   1          1     1
212        212             1   1          1     1
212        212             1   11111   1  1111  1
212        212             1       1   1111  1  1
212        212             1       1            1
212        212             1       1            1
212        212             1       11111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212             1   1  1       1     1
212        212             1   1  1       1     1
212        212             1   1111    1  1111  1
212        212             1      1    1111  1  1
212        212             1      1             1
212        212             1      1             1
212        212             1      111111111111111
212        212             1                    1
212        212             1                    1
212        212             1111111111111111111  1
212        212                1 1         1     1
212        212                111         1     1
212        2 2                  111    1  1111  1
212        272                  1 1    1111  1  1
212        212                  111111          1
21222222222212                     1 1          1
21111111111112                     11111111111111
 222222222222
